LeetCode第一题(梦开始的地方)

题目:

给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。

你可以假设每种输入只会对应一个答案,并且你不能使用两次相同的元素。

你可以按任意顺序返回答案。

示例 1:

复制代码
输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。

示例 2:

复制代码
输入:nums = [3,2,4], target = 6
输出:[1,2]

示例 3:

复制代码
输入:nums = [3,3], target = 6
输出:[0,1]

这题是一个很典型的使用哈希表的题目,一般第一时间想到的做法肯定是两个for循环进行遍历,但这样算法的时间复杂度已经到达了On的平方,这肯定不是我们想要的,所以我们可以使用哈希表来解决该题

java 复制代码
class Solution {
    public int[] twoSum(int[] nums, int target) {
        int n = nums.length;
        HashMap<Integer,Integer>map = new HashMap<>();
        for(int i = 0;i<n;i++){
            if(map.containsKey(target - nums[i])){
                x = map.get(targer - nums[i]);
                return new int[]{x,i};
            }
            map.put(nums[i],i);
        }
        return new int[0];
}
相关推荐
生态学者9 小时前
Global Change Biology | 森林越“步调一致”,反而越怕干旱?树木生长与叶片活动的同步之谜
大数据·人工智能·算法·r语言·微信公众平台
lsswear9 小时前
Agent 框架新手入门与实战部署指南
大数据·人工智能·算法
学逆向的9 小时前
C 循环结构的执行效率分析
c语言·开发语言·数据结构·网络安全
Data analyse45611 小时前
rnweb 回放数据量太大怎么办?分片存储与断点续传的实现思路
前端·网络·算法·数据分析
Navigator_Z12 小时前
LeetCode //C - 1293. Shortest Path in a Grid with Obstacles Elimination
c语言·算法·leetcode
Nil20813 小时前
leetcode 64最小路径和
算法·leetcode·职场和发展
光影少年13 小时前
AI Agent、自动化与未来工作
人工智能·算法·架构
牧羊人.33313 小时前
计算机视觉基础 第16章|EigenFace,FisherFace,LBPH传统人脸识别算法
人工智能·算法·计算机视觉
jeo陽13 小时前
04-循环实战:素数、最大公约数、级数求和与枚举法
c语言·开发语言·数据结构
Nil20813 小时前
leetcode 72编辑距离
算法·leetcode·职场和发展